-----------------------------------------------------------------------
--
--  test bench UNIR O PROCESSADOR CLEOPATRA  MICROBLAZE
--
--  MORAES -- 01/NOVEMBRO DE 2005 - alterado em 02/junho/2006
--
-----------------------------------------------------------------------
library ieee;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_1164.all;


entity user_logic_tb is
                generic(
                C_DWIDTH : INTEGER := 32;
                C_NUM_CE : INTEGER := 4 );
end user_logic_tb;

architecture TB_ARCHITECTURE of user_logic_tb is         

    component user_logic
--            generic(
--            C_DWIDTH : INTEGER := 32;
--            C_NUM_CE : INTEGER := 4 );
    port(
            user_int : out std_logic;
            Bus2IP_Clk : in std_logic;
            Bus2IP_Reset : in std_logic;
            Bus2IP_Data : in std_logic_vector(0 to (C_DWIDTH-1));
            Bus2IP_BE : in std_logic_vector(0 to (C_DWIDTH/8-1));
            Bus2IP_RdCE : in std_logic_vector(0 to (C_NUM_CE-1));
            Bus2IP_WrCE : in std_logic_vector(0 to (C_NUM_CE-1));
            IP2Bus_Data : out std_logic_vector(0 to (C_DWIDTH-1));
            IP2Bus_Ack : out std_logic;
            IP2Bus_Retry : out std_logic;
            IP2Bus_Error : out std_logic;
            IP2Bus_ToutSup : out std_logic );
    end component;

    signal Bus2IP_Clk :     std_logic := '0';
    signal Bus2IP_Reset :   std_logic;
    signal Bus2IP_Data :    std_logic_vector(0 to (C_DWIDTH-1));
    signal Bus2IP_BE :      std_logic_vector(0 to (C_DWIDTH/8-1));
    signal Bus2IP_RdCE :    std_logic_vector(0 to (C_NUM_CE-1));
    signal Bus2IP_WrCE :    std_logic_vector(0 to (C_NUM_CE-1));
    signal user_int :       std_logic;
    signal IP2Bus_Data :    std_logic_vector(0 to (C_DWIDTH-1));
    signal IP2Bus_Ack :     std_logic;
    signal IP2Bus_Retry :   std_logic;
    signal IP2Bus_Error :   std_logic;
    signal IP2Bus_ToutSup : std_logic;
        
    type mem_rom is array (0 to 9) of std_logic_vector(7 downto 0);
    constant wd_rom1 : mem_rom := ( x"A1", x"34", x"80", x"11", x"27", x"33", x"44", x"A2", x"AA", x"27" );

begin


        
     UUT : user_logic
--                generic map (
--                        C_DWIDTH => C_DWIDTH,
--                        C_NUM_CE => C_NUM_CE
--                )

                port map (
                        user_int => user_int,
                        Bus2IP_Clk => Bus2IP_Clk,
                        Bus2IP_Reset => Bus2IP_Reset,
                        Bus2IP_Data => Bus2IP_Data,
                        Bus2IP_BE => Bus2IP_BE,
                        Bus2IP_RdCE => Bus2IP_RdCE,
                        Bus2IP_WrCE => Bus2IP_WrCE,
                        IP2Bus_Data => IP2Bus_Data,
                        IP2Bus_Ack => IP2Bus_Ack,
                        IP2Bus_Retry => IP2Bus_Retry,
                        IP2Bus_Error => IP2Bus_Error,
                        IP2Bus_ToutSup => IP2Bus_ToutSup
                );       
                

     Bus2IP_Clk <=  not Bus2IP_Clk after 10 ns;
  
     Bus2IP_Reset <= '0', '1' after 120 ns, '0' after 240 ns;
      
      
     process
       variable cont : integer := 0;
       begin  

         Bus2IP_WrCE <= "0000";
                 
         wait for 300 ns;
         
         Bus2IP_Data <= x"000000" & wd_rom1(cont);
         Bus2IP_WrCE <= "0100"; 
         wait for 60 ns;
         Bus2IP_WrCE <= "0000";
         
         wait for 100 ns;   -- tempo para a prxima instruo
         
         Bus2IP_Data <= x"00000001";   -- sobe o reset
         Bus2IP_WrCE <= "1000";
         wait for 60 ns;
         Bus2IP_WrCE <= "0000";
        
         wait for 100 ns;
 
                 
         Bus2IP_Data <= x"00000000";   -- desce o reset
         Bus2IP_WrCE <= "1000";
         wait for 60 ns;
         Bus2IP_WrCE <= "0000";
        
         wait for 100 ns;

                 
         wait until user_int='1' ;     -- espera interrupo vinda do user_logic (halt da cleo)        
              
         cont := cont + 1;
         if cont=10 then cont:=0; end if;       
         
               
     end process;
          
         
end TB_ARCHITECTURE;

